//Some Basic Configuration   
#define DEFAULT_MODULE_ID 0x00030000 // Module Id ( 16bit what are you?) (16bit who are you?) 0003 One chanel relay board
#define DEFAULT_ADDRESS_HIGH 0x19
#define DEFAULT_ADDRESS_LOW 0x37

//


//HAL
   #include "mcu_config.h"
   #include "simple_time.h"
   #include "simple_serial.h"
   #include "simple_nvm.h"

//Declare it:
   //Framework:
   #include "simple_serial_mac_declare.h"
   //Aplication Modify below:
   #include "app_declare.h"
   //EO Modify

//Implement it:
   //Framework:
   #include "simple_net.h"
   #include "simple_serial_mac.h"
   #include "simple_ts.h"
   //Applicaition Modify below:
   //EO Modify

//MAIN --------------------------------------------------------------------------

void main()
{
unsigned int8 temp;
   setup_adc_ports(NO_ANALOGS|VSS_VDD);
   setup_adc(ADC_OFF);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_8);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DIV_BY_1, 124, 1);

   setup_ccp1(CCP_OFF);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);
   setup_oscillator(OSC_8MHZ);
   output_float(PIN_A3); // Make pin GP3 into an input
   enable_interrupts(INT_TIMER0);
   enable_interrupts(GLOBAL);

   reload_eeprom_config();

   
while( 1)
{
//   destination_pwm =getc();
//   putc(0x35);
   if(kbhit())
   {
     disable_interrupts(GLOBAL);
     temp = getc();
     Receiver_FSM(temp);
    // putc(temp);
     enable_interrupts(GLOBAL);
   }

}
  
//you can never escape from the main loop! muhahaha
}

//EO MAIN --------------------------------------------------------------------------

//Application specific commands
#define CMD_SET_RLY_ON     0x30   //Turns on the relay output (oh.. really?)
#define CMD_SET_RLY_OFF    0x31   //Turns off the relay output (duh!!)
//Future implementation
#define CMD_SAVE_RLY_STATE 0x32   //Saves current relay state to nvram and restore on poweron


void app_packet_handler(unsigned int8 * packet,  int1 isBroadcast)
{
   switch( packet[CMD_POS])
   {
     case CMD_SET_RLY_ON:
      //brings the relay on
      output_high(RLY_OUTPUT);
      if(!isBroadcast)send_msg(0xFF,0xFF,CMD_ACK,packet,0); //Ack to the message
     break;
    case CMD_SET_RLY_OFF:
      //brings the relay off
      output_low(RLY_OUTPUT);
      if(!isBroadcast)send_msg(0xFF,0xFF,CMD_ACK,packet,0); //Ack to the message
     break;
   }
}
